Summary: Tools for configuring the console.
Name: console-tools
%define CTVER	0.3.3
%define	CDVER	1999.08.29
%define DATA console-data-%{CDVER}
Version: 19990829
Release: 1.3.0
Group: Applications/System
Exclusiveos: Linux
Copyright: GPL
URL: http://www.multimania.com/ydirson/en/lct/
Source0: ftp://metalab.unc.edu/pub/Linux/system/keyboards/console-tools-%{CTVER}.tar.gz
Source1: ftp://metalab.unc.edu/pub/Linux/system/keyboards/%{DATA}.tar.gz
Source2: keytable.init
Source3: ftp://ftp.dementia.org/pub/linux/pc2sun.pl
Source4: console-tools-1998.08.11.add-ons-nosk.tar.gz
Source5: console-tools-0.3.3.sunfonts.tar.gz
Source6: kbd-1.03wip-turkish.tar.gz
Source7: kbd-ro.map.gz
Source8: kbd-sr.map.gz
Source9: ucw-fonts-1.1.1.tar.gz
Source10: kbd-0.96-latin0.tar.gz
Source11: kbd-0.96-amiga.tar.gz
Source12: sunt4-no-latin1.map.gz
Source13: lat2u-font.tar.gz
Source14: data-addon.tar.gz
Source15: console-fonts-cyr.tgz

Patch0: console-tools-1998.08.11.resizecons.patch
# Patch3: console-tools-1999.08.29.sparc.patch
# Patch4: console-tools-1998.08.11.kmaps.patch
Patch5: console-tools.fonts.patch
# Allow consolechars & loadkeys to run from the root partition
Patch6: console-tools-rootpart.patch
# Add /etc/sysconfig/console (without subdirs) to the search path
# Patch7: console-tools-searchpath.patch
# Patch8: console-tools.fonts2.patch
# Patch9: console-tools.fonts3.patch
# Don't load a directory as a keymap. Duh.
Patch11: console-tools-resizecons.patch
# Euro support
# Patch12: console-data-1999.08.29-redhat.patch
# Fix acm handling. Duh.
# Patch13: console-tools-0.3.3.acm.patch
# fix delete key behaviour on type4/5 keyboards on sun to match intel
Patch14: console-tools-fixdel.patch
# Patch15: console-tools-unicyr.patch
# Fix psfgettable on BE
Patch16: console-tools-0.3.3.psfgettable.patch

#BuildRequires: sgml-tools
Prereq: /sbin/chkconfig fileutils sed
Obsoletes: kbd
Provides: kbd
BuildRoot: /var/tmp/%{name}-root

%description
The console-tools package contains tools for managing a Linux 
system's console's behavior, including the keyboard, the screen 
fonts, the virtual terminals and font files.

%prep
%setup -q -n console-tools-%{CTVER} -a 4 -a 6 -a 9 -a 10 -a 13 -a 14 -a 15
mv -f data %{DATA}
mv -f consolefonts/* %{DATA}/consolefonts
mv -f console-fonts-cyr/consolefonts/* %{DATA}/consolefonts
mv -f console-fonts-cyr/consoletrans/* %{DATA}/consoletrans
tar xzf %{SOURCE1}
mv -f %{DATA} data
tar xzf %{SOURCE5}
mv -f data %{DATA}
cd %{DATA}
# %patch0 -p1
%patch5 -p1
# %patch12 -p1 -b .euro
cd ..
%patch6 -p1 -b .rootpart
# %patch7 -p1 -b .searchpath
%patch11 -p1 -b .resizecons
# %patch13 -p1 -b .acmpatch
%patch14 -p1 -b .fixdel
# %patch15 -p1 -b .unicyr
%patch16 -p1 -b .psfgettable

%build
%ifarch i386 i486 i586 i686
DISABLE_RESIZECONS=
%else
DISABLE_RESIZECONS=--disable-resizecons
%endif

cd %{DATA}
CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -static" LDFLAGS="-static" ./configure --prefix=/usr \
  --datadir='${prefix}/lib/kbd' --enable-localdatadir=/etc/default/console \
  $DISABLE_RESIZECONS --mandir=$RPM_BUILD_ROOT/%{_mandir}
cd ..
CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -static" LDFLAGS="-static" ./configure --prefix=/usr \
  --datadir='${prefix}/lib/kbd' --enable-localdatadir=/etc/default/console \
  $DISABLE_RESIZECONS --mandir=$RPM_BUILD_ROOT/%{_mandir}
cd %{DATA}
make CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE" LDFLAGS=-s prefix=/usr
cd ..
make CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE" LDFLAGS=-s prefix=/usr

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr

# Don't ship zero-length documentation
find doc %{DATA}/doc -size 0b | xargs rm -f

cd %{DATA}
make install prefix=$RPM_BUILD_ROOT/usr mandir=$RPM_BUILD_ROOT/%{_mandir}
cd ..
make install prefix=$RPM_BUILD_ROOT/usr mandir=$RPM_BUILD_ROOT/%{_mandir}

make -C %{DATA}/consolefonts $XXXFONTS
for F in $XXXFONTS
do
  install -c -m 0644 %{DATA}/consolefonts/$F $RPM_BUILD_ROOT/usr/lib/kbd/consolefonts/$F
done

file $RPM_BUILD_ROOT/usr/bin/* | grep ELF | cut -f 1 -d ':' | xargs strip

# don't give loadkeys SUID perms
chmod 755 $RPM_BUILD_ROOT/usr/bin/loadkeys

# other keymaps
for map in ro sr ; do
   install -m 644 $RPM_SOURCE_DIR/kbd-$map.map.gz \
      $RPM_BUILD_ROOT/usr/lib/kbd/keymaps/i386/qwerty/$map.kmap.gz
done

install -m 644 $RPM_SOURCE_DIR/sunt4-no-latin1.map.gz \
	$RPM_BUILD_ROOT/usr/lib/kbd/keymaps/sun/sunt4-no-latin1.map.gz

install -d -m 755 $RPM_BUILD_ROOT/etc/init.d
install -d -m 755 $RPM_BUILD_ROOT/etc/rc{2,3,5}.d

install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/etc/init.d/keytable

mkdir -p $RPM_BUILD_ROOT/bin
for foo in loadkeys consolechars ; do
  mv $RPM_BUILD_ROOT/usr/bin/$foo $RPM_BUILD_ROOT/bin
  ln -s /bin/$foo $RPM_BUILD_ROOT/usr/bin/$foo
done

%ifarch sparc
install -c -m 755 $RPM_SOURCE_DIR/pc2sun.pl $RPM_BUILD_ROOT/usr/lib/kbd/keytables
%endif

%ifnarch i386 i486 i586 i686
rm -f $RPM_BUILD_ROOT%{_mandir}/resizecons.8
%endif

chmod +x $RPM_BUILD_ROOT/usr/lib/*.so*
strip --strip-unneeded -R .comments $RPM_BUILD_ROOT/usr/lib/*.so*

ln -sf lat0-sun16.psf.gz $RPM_BUILD_ROOT/usr/lib/kbd/consolefonts/lat1-sun16.psf.gz
ln -sf lat0-sun16.psf.gz $RPM_BUILD_ROOT/usr/lib/kbd/consolefonts/lat5-sun16.psf.gz
gzip -9 < %{DATA}/consolefonts/cyr-sun16.psf > $RPM_BUILD_ROOT/usr/lib/kbd/consolefonts/cyr-sun16.psf.gz

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
/sbin/chkconfig --add keytable
if [ -f /etc/default/keyboard ] ; then
    . /etc/default/keyboard
    if [ -n "$KEYTABLE" ] ; then
        KT=`echo $KEYTABLE | sed -e "s/.*\///g" | sed -e "s/\..*//g"`
        echo "KEYTABLE=$KT" > /etc/default/keyboard
    fi
fi
if [ -f /etc/default/i18n ] ; then
   . /etc/default/i18n
   if [ -d /etc/default/console ] ; then
      if [ -n "$SYSFONT" ]; then
         cp -f /usr/lib/kbd/consolefonts/$SYSFONT* /etc/default/console
      fi
      if [ -n "$UNIMAP" ]; then
         cp -f /usr/lib/kbd/consoletrans/$UNIMAP* /etc/default/console
      fi
      if [ -n "$SYSFONTACM" ]; then 
         cp -f /usr/lib/kbd/consoletrans/$SYSFONTACM* /etc/default/console
      fi
   fi
fi

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del keytable
fi

%postun -p /sbin/ldconfig

%triggerpostun -- kbd
/sbin/chkconfig --add keytable

%files
%defattr(-,root,root)

%doc README NEWS RELEASE BUGS TODO
%doc doc/[cdf]* %{DATA}/doc/[cdf]* %{DATA}/doc/keymaps
%doc doc/README* %{DATA}/doc/README* doc/*.txt

%attr(0700,root,root) %config /etc/init.d/keytable

/usr/lib/*
/bin/consolechars
/bin/loadkeys
/usr/bin/charset
/usr/bin/chvt
/usr/bin/codepage
/usr/bin/consolechars
/usr/bin/deallocvt
/usr/bin/dumpkeys
/usr/bin/fgconsole
%ifarch i386 i486 i586 i686
/usr/bin/fix_bs_and_del
%endif
/usr/bin/getkeycodes
/usr/bin/kbd_mode
/usr/bin/loadkeys
/usr/bin/loadunimap
/usr/bin/mk_modmap
/usr/bin/mapscrn
/usr/bin/psfaddtable
/usr/bin/psfgettable
/usr/bin/psfstriptable
%ifarch i386 i486 i586 i686
/usr/bin/resizecons
%endif
/usr/bin/saveunimap
/usr/bin/screendump
/usr/bin/setfont
/usr/bin/setkeycodes
/usr/bin/setleds
/usr/bin/setmetamode
/usr/bin/setvesablank
/usr/bin/showcfont
/usr/bin/showkey
/usr/bin/unicode_start
/usr/bin/unicode_stop
/usr/bin/vcstime
/usr/bin/vt-is-UTF8
/usr/bin/writevt

%doc %{_mandir}/man1/*
%doc %{_mandir}/man4/*
%doc %{_mandir}/man5/*
%doc %{_mandir}/man8/*

%changelog
* Thu Apr 10 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.3.0
  - Initial build for EnGarde Secure Community 2 (Feint).

* Mon Feb 03 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.5.0
  - Initial build for EnGarde v1.5 (Thrust).

* Mon Feb 11 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.2.0
  - Initial build for EnGarde v1.2 (Parry).

* Tue Nov 06 2001 Pete O'Hara <pete@guardiandigital.com>
- Version 19990829, Release 1.1.1
  - keytable initfile needed run level 3 added for 
	chkconfig

* Tue Aug 07 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 19990829, Release 1.1.0
  - Initial build for EnGarde v1.1 (Balestra).


* Tue Mar 27 2001 Ryan W. Maple <ryan@guardiandigital.com>
  - Updated initscripts.


* Thu Mar 15 2001 Ryan W. Maple <ryan@guardiandigital.com>
  - Updated initscripts.


* Mon Dec 04 2000 Pete O'Hara <pete@guardiandigital.com>
- chmod 700 chgrp root /etc/init.d/keytable

* Thu Nov 30 2000 Pete O'Hara <pete@guardiandigital.com>
- changed init file reference to /etc/sysconfig/keyboard
	to /etc/default/keyboard

* Fri Nov 24 2000 Pete O'Hara <pete@guardiandigital.com>
- expanded "ifarch" and "ifnarch" statements that only specified 
	i386 to include i(456)86

* Sun Nov 19 2000 Dave Wreski <dave@guardiandigital.com>
- FHS fixes
- /etc/sysconfig -> /etc/default

* Thu Nov 09 2000 Pete O'Hara <pete@guardiandigital.com>
- removed use of /etc/rc.d

* Mon Mar  6 2000 Jakub Jelinek <jakub@redhat.com>
- New -sun16 fonts (cyr-sun16 plus a few modifications
  to lat0-sun16 and lat2-sun16; lat5-sun16 merged into lat0-sun16)
- koi8-r and koi8-u acm maps
- Fix an endianess bug in psfgettable

* Thu Mar  2 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix up support for Russian (Bugs #9898 and #9908)
  Seems console-tools can't handle gzip'ing on all file types.

* Tue Feb 29 2000 Preston Brown <pbrown@redhat.com>
- the delete key mapping on sun type 4/5 keyboards matches intel now.

* Fri Feb 25 2000 Cristian Gafton <gafton@redhat.com>
- update romanian keyboard

* Fri Feb 25 2000 Jakub Jelinek <jakub@redhat.com>
- Fix acm loading, so it is able to cope again with
  what previous console-tools were loading and not only
  wg-15 glibc format.
- Painted yet another Turkish font compatible with lat0-sun16.

* Thu Feb 24 2000 Matt Wilson <msw@redhat.com>
- updated Turkish font

* Thu Feb 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix up support for Russian
  (fonts from leon@geon.donetsk.ua, Bug #9519)

* Fri Feb  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Rebuild to compress man pages
- strip libraries

* Wed Jan 11 2000 Bill Nottingham <notting@redhat.com>
- fix some of the old patches

* Fri Nov  5 1999 Bernhard Rosenkrnzer <bero@redhat.com>
- Update to console-tools 0.3.3 and console-data 1999.08.29
- Euro support
- Support for Windoze keys (used to switch between ttys)

* Sun Sep  5 1999 Jeff Johnson <jbj@redhat.com>
- fix resizecons (#3986).
- consolechars can't handle gzipped old format koi8u2ruscii (#4022).

* Mon Aug 23 1999 Bill Nottingham <notting@redhat.com>
- a directory is not a keymap.

* Fri Aug 20 1999 Bill Nottingham <notting@redhat.com>
- triggerpostun on kbd so we don't lose our chkconfig links

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging

* Thu Apr 15 1999 Bill Nottingham <notting@redhat.com>
- make keytable %post handle us.map better

* Thu Apr 15 1999 Jeff Johnson <jbj@redhat.com>
- hotwire sun fonts.

* Wed Apr 14 1999 Bill Nottingham <notting@redhat.com>
- %post changes; just copy the user's configured font/map/etc.

* Wed Apr 14 1999 Matt Wilson <msw@redhat.com>
- added fonts RUSCII_*, koi8u_*, and acm koi8u2ruscii from
  Leon Kanter <leon@geon.donetsk.ua>

* Mon Apr 12 1999 Bill Nottingham <notting@redhat.com>
- removed sh-utils from prereq.
- added sed to prereq

* Fri Apr  9 1999 Jeff Johnson <jbj@redhat.com>
- more latin2 fonts (Peter Ivanyi).

* Thu Apr  8 1999 Bill Nottingham <notting@redhat.com>
- added sh-utils to prereq.

* Mon Apr  5 1999 Bill Nottingham <notting@redhat.com>
- /etc/sysconfig/console support
- add setsysfont to init script

* Mon Mar 29 1999 Peter Ivanyi <ivanyi@internet.sk>
- more fixes.

* Thu Mar 25 1999 Peter Ivanyi <ivanyi@internet.sk>
- add ucw-fonts-1.1.tar.gz
- delete obsolete sk keymaps from console-tools-1998.08.11.add-ons.

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- added norwegian sun4 keymap support

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Fri Mar 12 1999 Jeff Johnson <jbj@redhat.com>
- update to 1999.03.02.

* Tue Feb 16 1999 Jeff Johnson <jbj@redhat.com>
- repackage for Red Hat 6.0

* Wed Jan 30 1999 Alex deVries <puffin@redhat.com>
- added amiga support for Jes Sorensen

* Mon Dec 07 1998 Jakub Jelinek <jj@ultra.linux.cz>
- some keymaps were including "*.map", which has to be
  replaced by "*.kmap"

* Fri Dec 04 1998 Jakub Jelinek <jj@ultra.linux.cz>
- upgrade to console-tools, added new sun keymaps,
  new sun fonts for latin0/1 and latin2, iso15.acm
  and iso02+euro.acm.
- Print the verbose messages only if verbose was 
  specified on command line.

* Thu Oct 01 1998 Cristian Gafton <gafton@redhat.com>
- added Euro (latin0) support from Guylhem Aznar

* Sun Sep 27 1998 Cristian Gafton <gafton@redhat.com>
- fix the name the ro and sr maps are installed under
- slovak keymaps
- ro.map and sr.map are welcomed to the club
- enable turkish again

* Mon Aug 24 1998 Cristian Gafton <gafton@redhat.com>
- KEYTABLE should not have the full patch name (%post hack)

* Fri Aug 21 1998 Jeff Johnson <jbj@redhat.com>
- install keymaps on tty0 w/o using (non-installed) open(1).

* Tue Jul 14 1998 Jeff Johnson <jbj@redhat.com>
- updated to 0.96a.

* Thu Jun 11 1998 Mikael Hedin <micce@irf.se>
- specify VT0 in case we use a serial console

* Wed Jun 10 1998 Jeff Johnson <jbj@redhat.com>
- quotes permit multiple keytables in keytable.init (problem #675)

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Thu May 07 1998 Donnie Barnes <djb@redhat.com>
- added some extra turkish support

* Thu Apr 30 1998 Cristian Gafton <gafton@redhat.com>
- fixes for building on alpha
- completed buildroot usage

* Thu Apr 23 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhanced initscript

* Wed Apr 08 1998 Erik Troan <ewt@redhat.com>
- updated to 0.95

* Wed Mar 25 1998 Erik Troan <ewt@redhat.com>
- fixed /tmp exploit

* Wed Nov 05 1997 Donnie Barnes <djb@redhat.com>
- added SPARC stuff (finally!), Thanks to eduardo@medusa.es for most of it.
- added buildroot
- cleaned up the file list
- moved to rev 5 because the contrib ver rel was 4

* Mon Oct 20 1997 Donnie Barnes <djb@redhat.com>
- updated from 0.91 to 0.94
- added chkconfig support
- spec file cleanups

* Tue Jun 17 1997 Erik Troan <ewt@redhat.com>
- built against glibc
